;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
; USB2 nuevo codigo por cortesia de USB (jeje).              
;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

;--------------------------------------------------------------------------

;                   ͻ
;                    ESQUEMA DE CONEXIONES PIC12C509A 
;                   ͼ
;
;                            ͻ  ͻ
;                                  ͼ      
;                       +5V ̹1  PIC12C508A  8̹ MASA
;                               PIC12C508A   
;                           ̹2 GPIO5  GPIO0 7̹                               
;                                            
;                           ̹3 GPIO4  GPIO1 6̹ TXSCEE    
;                                            
;                  /RESET=0 ̹4 GPIO3  GPIO2 5̹                
;                                            
;                            ͼ
;           



;[1] +5VCC - SIN COMENTARIOS 
;[4] PS2_RESET - ES IGUAL A 0 CUANDO PULSAMOS EL RESET DE LA PS2  
;[6] TX_SCEE - ES POR DONDE TRANSMITE VIA SERIE "SCEE" 
;[8] MASA - SIN COMENTARIOS 


;--------------------------------------------------------------------------

;ͻ
; PROCESADOR A EMPLEAR PIC12C508A 
;ͼ
P509A EQU 0          ;0=PIC12C508A 1=PIC12C509A
 IF        P509A
 list      p=12c509A
 include   "p12c509A.inc"
 ELSE
 list      p=12c508A
 include   "p12c508A.inc"
 ENDIF

;ͻ
; FUSIBLES, WASDOG, OSCILADOR ETC.. 
;ͼ
 __FUSES _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC

;ͻ
; NOTACION DECIMAL 
;ͼ
 radix   dec
;--------------------------------------------------------------------------

;ͻ
; VARIABLES DE RAM INTERNA 
;ͼ
 cblock 0x0B
        RAM_0B  ;CONTADOR PAUSA
        RAM_0C  ;CONTADOR
        RAM_0D  ;CONTADOR PAUSA
        RAM_0E  ;CANTIDAD DE BYTES A ENVIAR DE LA TABLA
        RAM_0F  ;CANTIDAD DE BITS A ENVIAR DEL BYTE
        RAM_10  ;NO UTILIZADA
        RAM_11  ;CONTADOR W EN PAUSA Wx199
        RAM_12  ;CONTADOR 199 EN PAUSA Wx199
        RAM_13  ;BYTE LEIDO DE LA TABLA
        RAM_14  ;PUNTERO DEL BYTE DE LA TABLA
        RAM_15  ;MASCARA ESTADO DE LOS BIT DEL PUERTO
       

     
 endc
;--------------------------------------------------------------------------

;ͻ
; VECTOR DE RESET 
;
        org	0x0
        movwf   OSCCAL          ;CALIBRA EL OSCILADOR INTERNO
        goto    COMIENZO        ;SALTA LA COMIENZO DEL PROGRAMA

;--------------------------------------------------------------------------

;ͻ
; VERSION DEL PROGRAMA (CODIGO INUTIL) 
;ͼ
        retlw   'U'
        retlw   'S'
        retlw   'B'
        retlw   '2'
        retlw   'M'
        retlw   'O'
        retlw   'D'
        retlw   '4'
        retlw   'A'
    

        ;--------------------------------------------------------------------------

TABLA   addwf   PCL,F           ;TABLA PARA LA PS2 ASIA,AMERICA,EUROPA
        retlw   'S'
        retlw   'C'
        retlw   'E'
        retlw   'E'
 IF 0       
	retlw   'S'
        retlw   'C'
        retlw   'E'
        retlw   'I'
        retlw   'S'
        retlw   'C'
        retlw   'E'
        retlw   'A'
  ENDIF      

;ͻ
; PAUSA DE 50 MILISEGUNDOS 
;ͼ

PAUSA50MSG
        movlw   50              
;ͻ
; PAUSA DE (W x 1 MILISEGUNDO) 
;ͼ
PAUSAWX1MSG
        movwf   RAM_11          
ETI_042 movlw   199             
        movwf   RAM_12          
ETI_044 nop                     
        clrwdt                  
        decfsz  RAM_12,F        
        goto    ETI_044         
        nop                     
        decfsz  RAM_11,F        
        goto    ETI_042         
        retlw   3               
;--------------------------------------------------------------------------

;ͻ
; COMIENZO DEL PROGRAMA 
;ͼ
COMIENZO
        movlw   b'11000010'     ;CONFIGURA TMR0 PRESCALER = 1:8
        option                  ;OSCILADOR = 4MHZ

        movlw   255             ;INICIALIZA TODOS LOS PUERTOS
        movwf   RAM_15          ;EN ALTO Y RAM_15
	tris	GPIO		;
;--------------------------------------------------------------------------

;ͻ
; PAUSA DE ENCENDIDO DE 414 MILISEGUNDOS 
;ͼ
        

        movlw   2               ;100 MILISEGUNDOS
        movwf   RAM_0D          ;
ETI_107 call    PAUSA50MSG      ;       +
        decfsz  RAM_0D,F        ;
        goto    ETI_107         ;
        movlw   6               ;300 MILISEGUNDOS
        movwf   RAM_0D          ;
ETI_10C call    PAUSA50MSG      ;       +
        decfsz  RAM_0D,F        ;
        goto    ETI_10C         ;
        movlw   14              ;14 MILISEGUNDOS
        call    PAUSAWX1MSG     ;
;--------------------------------------------------------------------------

;ͻ
; LECTURA DE LAS 3 OPCIONES CON EL PULSADOR DE RESET DE LA CONSOLA 
;ͼ
;OPCION2 EL RESET NO HA SIDO PULSADO
;-----------------------------------
        btfsc   GPIO,3          ;SI EL RESET NO ESTA PULSADO
        goto    OPCION2         ;SALTA A OPCION1

;OPCION2 EL RESET HA SIDO PULSADO Y SE HA SOLTADO ANTES DE 2 SEGUNDOS
;----------------------------------------------------------------------
        movlw   40             ;
        movwf   RAM_0D          ;
ETI_115 btfsc   GPIO,3          ; 
        goto    OPCION2         ;SALTA A OPCION2 AL LEVANTAR EL RESET
        call    PAUSA50MSG      ;
        decfsz  RAM_0D,F        ;
        goto    ETI_115         ;

;OPCION1 EL RESET HA SIDO PULSADO Y NO SE HA SOLTADO ANTES DE 2 SEGUNDOS
;-------------------------------------------------------------------------
        goto    OPCION1         ;SI CONTINUA PULSADO SALTA A OPCION1
;--------------------------------------------------------------------------


;ͻ
; OPCION 1 (RESET PULSADO 2 SEGUNDOS) EL MODCHIP SE         
; DESHABILITA Y SOLO PODEMOS USAR JUEGOS ORIGINALES 
;ͼ
OPCION1
        btfss   GPIO,3          ;ESPERA A QUE SOLTEMOS EL
        goto    OPCION1         ;BOTON DE RESET
        movlw   b'00111111'     ;INICIALIZA TODOS LOS
        tris    GPIO            ;PUERTOS EN ALTO Y
OPCION11
        goto    OPCION11         ; esto cuelga el chip

;//////////////////////////////////////////////////////
;//  NUEVO CODIGO QUE PERMITE COPIAS Y ORIGINALES    //
;//////////////////////////////////////////////////////
OPCION2
        bcf     GPIO,1          ;INICIALIZA PUERTO TXSERIE EN ALTO
        bcf     RAM_15,1        ;
        movf    RAM_15,W        ;
	tris	GPIO
BUCLEA
	bsf     RAM_15,1   
        movf    RAM_15,W        ;
        tris    GPIO          ;
     
	movlw   30             ;
        movwf   RAM_0D         ;REPETIRA LA TRANSMISION durante 1 segundo y medio
ETI_o 
       call PAUSA50MSG
       btfss   GPIO,3          ;SI EL RESET  ESTA PULSADO
       goto    OPCION2         ;SALTA A OPCION2
       decfsz  RAM_0D,F        ;
        goto    ETI_o     


 
        movlw   8             ;8 VECES
        movwf   RAM_0D          ;REPETIRA LA TRANSMISION
        		 

ETI_122
       
        clrf    RAM_14          ;INICIALIZA PUNTERO A TABLA Y
        call    ENVIASCEE       ;TRANSMITE VIA SERIE HASTA EL INFINITO 'SCEE'
        btfss   GPIO,3          ;SI EL RESET  ESTA PULSADO
        goto    OPCION2         ;SALTA A OPCION2
        decfsz  RAM_0D,F 
        goto    ETI_122     
        goto BUCLEA   


;ͻ
; TRANSMITE VIA SERIE LA LICENCIA ('SCEE') CON 8 BIT DE DATOS Y 2 DE STOP A 250 BPS 
;ͼ
ENVIASCEE
        movwf   RAM_0D          ;SALVA W EN RAM_0D (INUTIL PUES NO LO USA)

        ; EL MENSAJE dura 250 ms

        movlw   74              ;74 MILISEGUNDOS DE ESPACIO ENTRE BYTES
        call    PAUSAWX1MSG     ;

        movlw   4               ;ENVIAREMOS 4 BYTES
        movwf   RAM_0E          ;DE LA TABLA
ETI_068
        movf    RAM_14,W        ;LEEMOS 1 BYTE DE
        call    TABLA           ;LA TABLA
        movwf   RAM_13          ;EN RAM_13
        comf    RAM_13,F        ;

        movlw   8               ;ENVIAREMOS 8
        movwf   RAM_0F          ;BITS DE CADA BYTE

        bsf     RAM_15,1        ;ENVIA EL BIT DE START VIA SERIE
        movf    RAM_15,W        ;
	tris	GPIO		;

        movlw   4               ;4 MILISEGUNDOS DEL ANCHO DEL BIT DE START
        call    PAUSAWX1MSG     ;

ETI_073
        rrf     RAM_13,F        ;ENVIA 1 BIT DEL BYTE VIA SERIE
        movlw   b'11111000'     ;
	movwf	GPIO		;
        btfsc   STATUS,0        ;
        bsf     RAM_15,1        ;
        btfss   STATUS,0        ;
        bcf     RAM_15,1        ;
        movf    RAM_15,W        ;
	tris	GPIO		;

        movlw   4               ;4 MILISEGUNDOS DEL ANCHO DEL BIT
        call    PAUSAWX1MSG     ;

        decfsz  RAM_0F,F        ;CONTINUAMOS HASTA
        goto    ETI_073         ;ENVIAR LOS 8 BITS DEL BYTE

        bcf     RAM_15,1        ;ENVIA 2 BITS DE STOP
        movf    RAM_15,W        ;
	tris	GPIO		;

        movlw   8               ;8 MILISEGUNDOS DEL ANCHO DE
        call    PAUSAWX1MSG     ;LOS 2 BITS DE STOP

        incf    RAM_14,F        ;INCREMENTA PUNTERO DE LA TABLA

        decfsz  RAM_0E,F        ;CONTINUA HASTA
        goto    ETI_068         ;ENVIAR LOS 4 BYTES DE LA TABLA

        retlw   3               ;RETORNA CON W=03H



	end

